<template>
  <div id="app">
    <Header v-if="screen" @take-appointment="login" />
    <div class="container">
      <TakeAppointment
        :warningMail="warningMail"
        :warningPassword="warningPassword"
        v-if="screen === 'TakeAppointment'"
        @emit-valid-email="validemail" 
        @registr="registr"
        @back-home="backHome"
      />
      <SignUp v-if="screen === 'SignUp'" @accept="singing" />
      <ReserveAppointment v-if="screen === 'ReserveAppointment'" />
      <EditAppointment
        v-if="screen === 'EditAppointment'"
        :events="userSelected"
        @btn-conferm-edit="confermeditUser"
      />
      <AppointementPage
        v-if="screen === 'AppointementPage'"
        :events="arrayevents"
        @button-delete="deleteUser"
        @button-edit="editUser"
        @conferm-appointment="reservNewAppointment"
        @disconnect ="backHome"
      />
      <Formulario v-if="screen === 'Formulario'" />
      <HomePageServices v-if="screenHome" />
      <Product v-if="screenHome" />
      <Admin  v-if="screen === 'Admin'" 
         :events="arrayevents"
        @button-delete="deleteUser"
        @button-edit="editUser"
        @conferm-appointment="reservNewAppointment"
         @disconnect ="backHome" />
    </div>

    <Footer />
  </div>
</template>
<script>
import Header from "@/components/Header.vue";
import TakeAppointment from "@/components/TakeAppointment.vue";
import ReserveAppointment from "@/components/ReserveAppointment.vue";
import SignUp from "@/components/SignUp.vue";
import HomePageServices from "@/components/HomePageServices.vue";
import EditAppointment from "@/components/EditAppointment.vue";
import AppointementPage from "@/components/AppointementPage.vue";
import Product from "@/components/Product.vue";
import Formulario from "@/components/Formulario.vue";
import Footer from "@/components/Footer.vue";
import Admin from "@/components/Admin.vue";
import api from "@/api.js";
export default {
  name: "App",
  data() {
    return {
      URL1: "api/events",
      URL2: "api/user2",
      screen: "Header",
      screenHome: true,
      userId: null,
      completeURL: "",
      arrayevents: [],
      userSelected: "",
      logged: [],
      warningMail: false,
      warningPassword: false,
      id_actual_user: "",
      role: ""
    };
  },

  components: {
    Header,
    TakeAppointment,
    ReserveAppointment,
    SignUp,
    EditAppointment,
    AppointementPage,
    HomePageServices,
    Product,
    Formulario,
    Admin,
    Footer
  },

  created() {
    this.callApievents();
  },

  methods: {
    async callApievents() {
      const result = await fetch(this.URL1);
      const data = await result.json();
      this.arrayevents = data;
    },

    login() {
      this.screenHome = false;
      this.screen = "TakeAppointment";
    },
     backHome() {
       console.log("IKHAN")
      this.screenHome = true;
      this.screen = "Header";
    },

    registr() {
      this.screen = "SignUp";
    },

    async reservNewAppointment(peluquero, title, start, end, classe) {
      /* if (
    date == null ||
    description == null ||
    starttime == null ||
    endtime == null
  ) {
    alert("Escribir informacion");
  } else { */
      await fetch(this.URL1, {
        method: "POST",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
          peluquero: peluquero,
          title: title,
          start: start,
          end: end,
          classe: classe + "€"
        })
      })
        .then(response => response.json())
        .catch(error => console.error("Error:", error))
        .then(response => console.log("Success:", response));
      console.log("moha");
      alert(
        "welcom to Peñascal barbershop your appointment has been regestred"
      );
      this.callApievents();
    },

    async singing(username, email, password, validaRepetirPassword) {
      if (
        username == null ||
        email == null ||
        password == null ||
        validaRepetirPassword == null
      ) {
        alert("Escribir informacion");
      } else {
        await fetch(this.URL2, {
          method: "POST",
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify({
            username: username,
            email: email,
            password: password,
            validaRepetirPassword: validaRepetirPassword
          })
        })
          .then(response => response.json())
          .catch(error => console.error("Error:", error))
          .then(response => console.log("Success:", response));
        alert("welcom to Peñascal barbershop");
        this.takeappointment();
      }
    },

    async validemail(email, password) {
      console.log("estoy aqui");
      this.logged = await api.login(email, password);
      if (this.logged.log_mensajes === "correo incorrecto") {
        this.warningMail = true;
      } else if (this.logged.log_mensajes === "contraseña incorrecta") {
        this.warningPassword = true;
      } else {
        this.id_actual_user = this.logged.idUser;
        this.role = this.logged.role;
        if(this.role==="Admin"){
          this.screen = "Admin";
        }
        else {
        this.goToHomePage();}
      }
    },
    goToHomePage() {
      this.screen = "AppointementPage";
    },
    async deleteUser(id) {
      console.log("ID");
      this.userId = id;
      this.completeURL = this.URL1 + "/" + this.userId;
      await this.deleteevents();
      await this.callApievents();
      console.log("7777");
    },
    async deleteevents() {
      await fetch(this.completeURL, {
        method: "Delete"
      }).then(response => response.json());
    },
    editUser(events) {
      this.userSelected = events;
      this.screen = "EditAppointment";
      this.action = "editar";
    },

    async confermeditUser(events) {
      const urlz = this.URL1 + "/" + events.id;
      console.log(urlz) + "jjjjjjjj";
      await fetch(this.URL1 + "/" + events.id, {
        method: "PUT",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
          peluquero: events.peluquero,
          title: events.title,
          start: events.start,
          end: events.end,
          classe: events.classe,
          id: events.id
        })
      }).then(response => response.json());
      this.screen = "AppointementPage";
    }
  }
};
</script>

<style></style>
